#include <stdlib.h>
#include <stdio.h>
#include <string.h>

static void MkOutFileName(char *outname, char *inname)
{  char *p;

   strcpy(outname, inname);
   p = strrchr(outname, '.');
   if (p != NULL)
   {
      strcpy(p, ".c");
   }
   else
   {
      strcat(outname, ".c");
   }
}

int main(int argc, char *argv[])
{  FILE *BinFile, *SrcFile;
   char outname[256];
   long Dummy;
   int i;

   if (argc != 3)
   {
      puts("Usage:");
      printf("%s <file> <name>\n", argv[0]);
      puts("makes c code from binary file");
   }
   else
   {
      MkOutFileName(outname, argv[1]);
      BinFile = fopen(argv[1], "r");
      if (BinFile != (FILE *)NULL)
      {
         SrcFile = fopen(outname, "wt");
         if (SrcFile != (FILE *)NULL)
         {
            fprintf(SrcFile, "char %s[] = {\n", argv[2]);
            do {
               Dummy = fread(outname, 1, 256, BinFile);
               if (Dummy > 0)
               {
                  for (i = 0; i < Dummy; i++)
                  {
                     fprintf(SrcFile, "0x%X,", outname[i]);
                  }
                  fputs("\n", SrcFile);
               }
            } while (Dummy > 0);
            fputs("};", SrcFile);
            fclose(SrcFile);
         }
         else
         {
            printf("can not open <%s>\n", outname);
         }
         fclose(BinFile);
      }
      else
      {
         printf("can not open <%s>\n", argv[1]);
      }
   }
}
